#ifndef BST_H_
#define BST_H_

#include <stddef.h>
#include <stdbool.h>

struct bst_node
   {
   struct bst_node * parent;
   struct bst_node * left;
   struct bst_node * right;
   void * data;
   };

struct bst
   {
   struct bst_node * root;
   size_t size;
   bool (*le)(void * a, void * b);
   bool (*eq)(void * a, void * b);
   };

struct bst * bst_new(bool (*le)(void * a, void * b), bool (*eq)(void * a, void * b));
void bst_delete(struct bst * bst);

void * bst_insert(struct bst * bst, void * data);

void * bst_search(struct bst * bst, void * data);
void * bst_search_iterative(struct bst * bst, void * data);

void * bst_minimum(struct bst * bst);
void * bst_maximum(struct bst * bst);

void bst_walk_inorder(struct bst * bst, void (*op)(void * data));

#endif
